`timescale 1ns / 1ps

module bg_buffer_tb_v;

	// Inputs
	reg i_clk;
	reg [7:0] i_pt0;
	reg [7:0] i_pt1;
	reg [1:0] i_at;
	reg [2:0] i_fh;
	reg i_load;
	reg i_shift_en;
	reg i_reset;

	// Outputs
	wire [3:0] o_pixel;

	// Instantiate the Unit Under Test (UUT)
	bg_buffer uut (
		.i_reset(i_reset),
		.i_clk(i_clk), 
		.i_pt0(i_pt0), 
		.i_pt1(i_pt1), 
		.i_at(i_at), 
		.i_fh(i_fh), 
		.i_load(i_load), 
		.i_shift_en(i_shift_en), 
		.o_pixel(o_pixel)
	);

	always #10 i_clk = ~i_clk;

	initial begin
		// Initialize Inputs
		i_clk = 0;
		i_pt0 = 0;
		i_pt1 = 0;
		i_at = 0;
		i_fh = 0;
		i_load = 0;
		i_shift_en = 1;
		i_reset = 1;

		// Wait 100 ns for global reset to finish
		#100;
		i_reset = 0;
        
		// Add stimulus here
		@(posedge i_clk);
		i_pt0 = 8'b01010101;
		i_pt1 = 8'b11001100;
		i_at = 2'b01;
		i_load = 1;
		@(posedge i_clk);
		i_load = 0;
		
		#1000;
		i_fh = 3'd7;
		
		i_reset = 1;
		// Wait 100 ns for global reset to finish
		#100;
		i_reset = 0;
        
		// Add stimulus here
		@(posedge i_clk);
		i_pt0 = 8'b01010101;
		i_pt1 = 8'b11001100;
		i_at = 2'b01;
		i_load = 1;
		@(posedge i_clk);
		i_load = 0;
	end
      
endmodule

