`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    22:53:55 04/17/2008 
// Design Name: 
// Module Name:    cartridge 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module cartridge(o_cpu_data, o_ppu_data, i_cpu_data, i_ppu_data, i_cpu_addr, i_ppu_addr, i_ppu_wr, i_cpu_wr, clk);
    output [7:0] o_cpu_data;
    output [7:0] o_ppu_data;
    input [7:0] i_cpu_data;
    input [7:0] i_ppu_data;
    input [15:0] i_cpu_addr;
    input [13:0] i_ppu_addr;
	 input i_ppu_wr, i_cpu_wr, clk;
	 
    reg [7:0] o_ppu_data;
	 reg [7:0] prg_rom_out, chr_ram_out;
	 reg [7:0] prg_rom [32767:0];
	 reg [7:0] chr_ram [8191:0]; //may be ram, may be rom, depending on the game

//Excite bike cart

initial begin
	//$readmemh("demo_prg.init", prg_rom, 0, 16383);
	//$readmemh("demo_prg.init", prg_rom, 16384, 32767);
	//$readmemh("demo_chr.init", chr_ram, 0, 8191);
//   $readmemh("EB_prg.init", prg_rom, 0, 16383);
//	$readmemh("EB_prg.init", prg_rom, 16384, 32767);
//	$readmemh("EB_chr.init", chr_ram, 0, 8191);
	$readmemh("SMB_prg.init", prg_rom, 0, 32767);
	$readmemh("SMB_chr.init", chr_ram, 0, 8191);
end

always @ (posedge clk) begin
	if (i_cpu_wr) begin
		prg_rom_out <= i_cpu_data;
		prg_rom[i_cpu_addr[14:0]] <= i_cpu_data;
	end else begin
		prg_rom_out <= prg_rom[i_cpu_addr[14:0]];
	end
end

always @(posedge clk) begin
	if (i_cpu_wr) begin
		chr_ram_out <= i_cpu_data;
		chr_ram[i_cpu_addr[12:0]] <= i_cpu_data;
	end else begin
		chr_ram_out <= chr_ram[i_cpu_addr[12:0]];
	end
end

assign o_cpu_data = (i_cpu_addr[15] ==1) ? prg_rom_out : chr_ram_out;

endmodule
