module controller_iface
(
	input i_clk,
	input i_reset,
	
	input [15:0] i_addr,
	input [7:0] i_wr_data,
	output [7:0] o_rd_data,
	input i_write_n,
	
	input i_a,
	input i_b,
	input i_start,
	input i_select,
	input i_up,
	input i_down,
	input i_left,
	input i_right
);

reg shift_load;
reg [7:0] shift;

assign o_rd_data = shift[0];

always @ (posedge i_clk or posedge i_reset) begin
	if (i_reset) begin
		shift <= 'b0;
		shift_load <= 'b0;
	end
	else begin
		if (shift_load) begin
			shift[0] <= i_a;
			shift[1] <= i_b;
			shift[2] <= i_select;
			shift[3] <= i_start;
			shift[4] <= i_up;
			shift[5] <= i_down;
			shift[6] <= i_left;
			shift[7] <= i_right;
		end
		
		if (i_addr == 16'h4016) begin
			if (i_write_n == 1'b0) begin
				shift_load <= {7'b0, i_wr_data[0]};
			end
			else begin
				shift <= {1'b0, shift[7:1]};
			end
		end
	end
end
		
	

endmodule
