`timescale 1ns / 1ps

module spr_buffers
(
	input i_clk,
	input i_reset,
	
	input [7:0] i_load,
	input i_enable,
	
	input [7:0] i_pt0,
	input [7:0] i_pt1,
	input [1:0] i_pal,
	input [7:0] i_sprite_x,
	input i_bgpri,
	input i_spr0,
	
	output [3:0] o_pixel,
	output o_bgpri,
	output o_spr0
);

wire [5:0] buf0_out;
spr_buffer buf0
(
	.i_clk(i_clk),
	.i_reset(i_reset),
	.i_load(i_load[0]),
	.i_enable(i_enable),
	.i_pt0(i_pt0),
	.i_pt1(i_pt1),
	.i_pal(i_pal),
	.i_sprite_x(i_sprite_x),
	.i_bgpri(i_bgpri),
	.i_spr0(i_spr0),
	.o_pixel(buf0_out[3:0]),
	.o_bgpri(buf0_out[4]),
	.o_spr0(buf0_out[5])
);

wire [5:0] buf1_out;
spr_buffer buf1
(
	.i_clk(i_clk),
	.i_reset(i_reset),
	.i_load(i_load[1]),
	.i_enable(i_enable),
	.i_pt0(i_pt0),
	.i_pt1(i_pt1),
	.i_pal(i_pal),
	.i_sprite_x(i_sprite_x),
	.i_bgpri(i_bgpri),
	.i_spr0(i_spr0),
	.o_pixel(buf1_out[3:0]),
	.o_bgpri(buf1_out[4]),
	.o_spr0(buf1_out[5])
);

wire [5:0] buf2_out;
spr_buffer buf2
(
	.i_clk(i_clk),
	.i_reset(i_reset),
	.i_load(i_load[2]),
	.i_enable(i_enable),
	.i_pt0(i_pt0),
	.i_pt1(i_pt1),
	.i_pal(i_pal),
	.i_sprite_x(i_sprite_x),
	.i_bgpri(i_bgpri),
	.i_spr0(i_spr0),
	.o_pixel(buf2_out[3:0]),
	.o_bgpri(buf2_out[4]),
	.o_spr0(buf2_out[5])
);

wire [5:0] buf3_out;
spr_buffer buf3
(
	.i_clk(i_clk),
	.i_reset(i_reset),
	.i_load(i_load[3]),
	.i_enable(i_enable),
	.i_pt0(i_pt0),
	.i_pt1(i_pt1),
	.i_pal(i_pal),
	.i_sprite_x(i_sprite_x),
	.i_bgpri(i_bgpri),
	.i_spr0(i_spr0),
	.o_pixel(buf3_out[3:0]),
	.o_bgpri(buf3_out[4]),
	.o_spr0(buf3_out[5])
);

wire [5:0] buf4_out;
spr_buffer buf4
(
	.i_clk(i_clk),
	.i_reset(i_reset),
	.i_load(i_load[4]),
	.i_enable(i_enable),
	.i_pt0(i_pt0),
	.i_pt1(i_pt1),
	.i_pal(i_pal),
	.i_sprite_x(i_sprite_x),
	.i_bgpri(i_bgpri),
	.i_spr0(i_spr0),
	.o_pixel(buf4_out[3:0]),
	.o_bgpri(buf4_out[4]),
	.o_spr0(buf4_out[5])
);

wire [5:0] buf5_out;
spr_buffer buf5
(
	.i_clk(i_clk),
	.i_reset(i_reset),
	.i_load(i_load[5]),
	.i_enable(i_enable),
	.i_pt0(i_pt0),
	.i_pt1(i_pt1),
	.i_pal(i_pal),
	.i_sprite_x(i_sprite_x),
	.i_bgpri(i_bgpri),
	.i_spr0(i_spr0),
	.o_pixel(buf5_out[3:0]),
	.o_bgpri(buf5_out[4]),
	.o_spr0(buf5_out[5])
);

wire [5:0] buf6_out;
spr_buffer buf6
(
	.i_clk(i_clk),
	.i_reset(i_reset),
	.i_load(i_load[6]),
	.i_enable(i_enable),
	.i_pt0(i_pt0),
	.i_pt1(i_pt1),
	.i_pal(i_pal),
	.i_sprite_x(i_sprite_x),
	.i_bgpri(i_bgpri),
	.i_spr0(i_spr0),
	.o_pixel(buf6_out[3:0]),
	.o_bgpri(buf6_out[4]),
	.o_spr0(buf6_out[5])
);

wire [5:0] buf7_out;
spr_buffer buf7
(
	.i_clk(i_clk),
	.i_reset(i_reset),
	.i_load(i_load[7]),
	.i_enable(i_enable),
	.i_pt0(i_pt0),
	.i_pt1(i_pt1),
	.i_pal(i_pal),
	.i_sprite_x(i_sprite_x),
	.i_bgpri(i_bgpri),
	.i_spr0(i_spr0),
	.o_pixel(buf7_out[3:0]),
	.o_bgpri(buf7_out[4]),
	.o_spr0(buf7_out[5])
);

spr_mux spr_mux_inst
(
	.i_buf0(buf0_out),
	.i_buf1(buf1_out),
	.i_buf2(buf2_out),
	.i_buf3(buf3_out),
	.i_buf4(buf4_out),
	.i_buf5(buf5_out),
	.i_buf6(buf6_out),
	.i_buf7(buf7_out),
	
	.o_pixel(o_pixel),
	.o_spr0(o_spr0),
	.o_bgpri(o_bgpri)
);

endmodule
