`timescale 1ns / 1ps

module spr_mux
(
	input [5:0] i_buf0,
	input [5:0] i_buf1,
	input [5:0] i_buf2,
	input [5:0] i_buf3,
	input [5:0] i_buf4,
	input [5:0] i_buf5,
	input [5:0] i_buf6,
	input [5:0] i_buf7,
	
	output [3:0] o_pixel,
	output o_spr0,
	output o_bgpri
);

// First stage muxes

wire [5:0] stage1_0 = (i_buf0[3:0] == 4'b0) ? i_buf1 : i_buf0;
wire [5:0] stage1_1 = (i_buf2[3:0] == 4'b0) ? i_buf3 : i_buf2;
wire [5:0] stage1_2 = (i_buf4[3:0] == 4'b0) ? i_buf5 : i_buf4;
wire [5:0] stage1_3 = (i_buf6[3:0] == 4'b0) ? i_buf7 : i_buf6;

// Second stage

wire [5:0] stage2_0 = (stage1_0[3:0] == 4'b0) ? stage1_1 : stage1_0;
wire [5:0] stage2_1 = (stage1_2[3:0] == 4'b0) ? stage1_3 : stage1_2;

// Last stage

wire [5:0] stage3 = (stage2_0[3:0] == 4'b0) ? stage2_1 : stage2_0;

assign o_pixel = stage3[3:0];
assign o_bgpri = stage3[4];
assign o_spr0 = stage3[5];

endmodule
