library verilog;
use verilog.vl_types.all;
entity regs is
    port(
        i_clk           : in     vl_logic;
        i_reset         : in     vl_logic;
        o_vblank_nmi    : out    vl_logic;
        i_cpu_addr      : in     vl_logic_vector(2 downto 0);
        i_cpu_write     : in     vl_logic;
        i_cpu_read      : in     vl_logic;
        i_cpu_write_data: in     vl_logic_vector(7 downto 0);
        o_cpu_read_data : out    vl_logic_vector(7 downto 0);
        o_cpu_datavalid : out    vl_logic;
        o_vram_addr     : out    vl_logic_vector(13 downto 0);
        o_vram_read     : out    vl_logic;
        o_vram_write    : out    vl_logic;
        i_vram_read_data: in     vl_logic_vector(7 downto 0);
        o_vram_write_data: out    vl_logic_vector(7 downto 0);
        o_pal_addr      : out    vl_logic_vector(4 downto 0);
        o_pal_wr_data   : out    vl_logic_vector(5 downto 0);
        o_pal_write     : out    vl_logic;
        i_pal_rd_data   : in     vl_logic_vector(5 downto 0);
        o_spr_addr      : out    vl_logic_vector(7 downto 0);
        o_spr_wr_data   : out    vl_logic_vector(7 downto 0);
        o_spr_write     : out    vl_logic;
        i_spr_rd_data   : in     vl_logic_vector(7 downto 0);
        i_hscroll_cnt_load: in     vl_logic;
        i_all_cnt_load  : in     vl_logic;
        i_hscroll_cnt_enable: in     vl_logic;
        i_vscroll_cnt_enable: in     vl_logic;
        i_rend_nt_read  : in     vl_logic;
        i_rend_at_read  : in     vl_logic;
        i_rend_bpt_read : in     vl_logic;
        i_rend_bpt_bit3 : in     vl_logic;
        i_rend_opt_read : in     vl_logic;
        i_rend_opt_bit3 : in     vl_logic;
        i_rend_opt_ptab : in     vl_logic;
        i_rend_opt_fv   : in     vl_logic_vector(2 downto 0);
        i_rend_opt_tilenum: in     vl_logic_vector(7 downto 0);
        o_attrib        : out    vl_logic_vector(1 downto 0);
        o_fine_h        : out    vl_logic_vector(2 downto 0);
        i_rend_set_vblank: in     vl_logic;
        i_rend_clear_vblank: in     vl_logic;
        i_rend_spritelimit: in     vl_logic;
        i_rend_primaryhit: in     vl_logic;
        o_object_pat_table: out    vl_logic;
        o_object_big    : out    vl_logic;
        o_object_clip   : out    vl_logic;
        o_object_enable : out    vl_logic;
        o_pf_clip       : out    vl_logic;
        o_pf_enable     : out    vl_logic
    );
end regs;
